/********************************** (C) COPYRIGHT *******************************
* File Name          : Main.C
* Author             : WCH
* Version            : V1.0
* Date               : 2019/07/22
* Description        : CH549 ADCʼADCжϺͲѯʽʾⲿͨԼڲ¶ȼ
*******************************************************************************/
#include ".\Public\CH549.H"
#include ".\Public\DEBUG.H"
#include "ADC.H"
#pragma  NOAREGS
volatile UINT8 GetValueFlag = 0;                                           //ADCжϷʽɼɱ־λ1Ч
#define power_supply_voltage 3.3	//оƬʵVCCŹ٣д٣ڼ
UINT32 FlashReadOTPword( UINT8 Addr )
{
    UINT32 temp;
    ROM_ADDR = Addr;
    ROM_CTRL = ROM_CMD_RD_OTP;
    temp = ROM_DATA_HI;
    temp <<= 16;
    temp |= ROM_DATA_LO;
    return temp;
}

int ADC_GetCurrentTS( UINT16 ts_v )
{
    UINT32  vol_ts;

    UINT16  D25_tem, D25_vol;
    UINT16  temperK;
    UINT32  temp;

    int     cal;

    temperK = 5;    // mV/16^C
    vol_ts = (ts_v << 4) / 12.926; //תmV
    temp = FlashReadOTPword( 0x0c );
	vol_ts  = vol_ts * ( power_supply_voltage / 5 );
    D25_tem = temp & 0xff;
    D25_vol = (temp >> 16);
    cal =  (vol_ts - D25_vol + temperK * D25_tem + (temperK >> 1)) / temperK ;
    return ( cal );
}


void main( )
{
    signed int tempreture;

    CfgFsys( );                                                            //CH549ʱѡ24MHz
    mDelaymS(5);                                                           //Լʱȴʱȶ
    mInitSTDIO( );                                                         //0ʼ
    printf("ADC demo start ...\n");

    ADC_InTSInit(); 		//ʼ¶ȼ

    while(1)
    {
        ADC_StartSample();                                                    //

        while((ADC_CTRL & bADC_IF) == 0)
        {
            ;    //ѯȴ־λ
        }

        ADC_CTRL = bADC_IF;                                                   //־
        tempreture = ADC_GetCurrentTS( ADC_DAT );
        printf("tmp:%d\n", (UINT16)(tempreture));                                       //¶ȣ϶
        mDelaymS(100);
    }

}
